"""
Some simple macros that are used to e.g. sort things within the jinja
templates. For the relevant documentation please see:

http://jinja.pocoo.org/docs/2.9/api/#custom-filters

Created 26-09-2017 by Josh Borrow (joshua.borrow@durham.ac.uk)
"""

import dateutil.parser as dp

def sort_cards(cards):
    """
    Sort the cards by date. 'cards' should have the following structure:
    [
       {
         ...
         date: "date"
       },
    ]
    
    A list will be returned where the cards are sorted by date.
    """

    dates = [
        dp.parse(card["date"]) for card in cards
    ]

    _, cards = zip(*sorted(zip(dates, cards)))

    # We want the newest to appear first.
    return reversed(cards)

